<?xml version="1.0" encoding="UTF-8"?>
<interface>
  <requires lib="gtk+" version="3.24"/>
  <requires lib="libadwaita" version="1.0"/>

  <template class="DBLegItem" parent="GtkBox">
    <style>
      <class name="card"/>
    </style>
    <child>
      <object class="GtkBox">
        <property name="orientation">vertical</property>
        <property name="hexpand">True</property>
        <property name="vexpand">False</property>
        <property name="margin-top">12</property>
        <property name="margin-bottom">12</property>
        <property name="margin-start">12</property>
        <property name="margin-end">12</property>
        <child>
          <object class="GtkBox">
            <property name="orientation">horizontal</property>
            <child>
              <object class="DBAltLabel" id="start_departure_label">
                <property name="valign">center</property>
                <property name="halign">start</property>
                <binding name="main">
                  <lookup name="planned-departure">
                    <lookup name="leg" type="DBLegItem">
                    </lookup>
                  </lookup>
                </binding>
                <binding name="alt">
                  <lookup name="departure">
                    <lookup name="leg" type="DBLegItem">
                    </lookup>
                  </lookup>
                </binding>
              </object>
            </child>
            <child>
              <object class="GtkBox">
                <property name="orientation">vertical</property>
                <child>
                  <object class="GtkSeparator">
                    <property name="orientation">vertical</property>
                    <property name="vexpand">True</property>
                    <property name="halign">center</property>
                    <property name="margin-start">18</property>
                    <property name="margin-end">18</property>
                  </object>
                </child>
                <child>
                  <object class="GtkImage">
                    <property name="icon-name">circle-outline-thick-symbolic</property>
                    <property name="pixel-size">13</property>
                    <property name="hexpand">False</property>
                  </object>
                </child>
                <child>
                  <object class="GtkSeparator">
                    <property name="orientation">vertical</property>
                    <property name="vexpand">True</property>
                    <property name="halign">center</property>
                    <property name="margin-start">18</property>
                    <property name="margin-end">18</property>
                  </object>
                </child>
              </object>
            </child>
            <child>
              <object class="GtkLabel">
                <style>
                  <class name="route-segment-station-start-end"/>
                </style>
                <property name="halign">start</property>
                <property name="ellipsize">end</property>
                <binding name="label">
                  <lookup name="name">
                    <lookup name="origin">
                      <lookup name="leg" type="DBLegItem">
                      </lookup>
                    </lookup>
                  </lookup>
                </binding>
              </object>
            </child>
            <child>
            </child>
            <child>
              <object class="DBAltLabel">
                <property name="valign">center</property>
                <property name="halign">end</property>
                <property name="hexpand">True</property>
                <binding name="main">
                  <lookup name="planned-departure-platform">
                    <lookup name="leg" type="DBLegItem"/>
                  </lookup>
                </binding>
                <binding name="alt">
                  <lookup name="departure-platform">
                    <lookup name="leg" type="DBLegItem"/>
                  </lookup>
                </binding>
              </object>
            </child>
          </object>
        </child>

        <child>
          <object class="GtkBox">
            <property name="orientation">horizontal</property>
            <child>
              <object class="AdwBin" id="spacing_1"/>
            </child>
            <child>
              <object class="GtkSeparator">
                <property name="orientation">vertical</property>
                <property name="margin-start">18</property>
                <property name="margin-end">18</property>
              </object>
            </child>
            <child>
              <object class="GtkBox">
                <property name="orientation">vertical</property>
                <property name="margin-top">6</property>
                <property name="margin-bottom">6</property>
                <property name="spacing">6</property>
                <child>
                  <!-- XXX: Somewhat hacky. Replace with AdwWrapBox when it comes out. https://gitlab.gnome.org/GNOME/libadwaita/-/merge_requests/219 -->
                  <object class="GtkFlowBox">
                    <property name="orientation">horizontal</property>
                    <property name="margin-bottom">6</property>
                    <property name="column-spacing">12</property>
                    <property name="row-spacing">0</property>
                    <property name="max-children-per-line">999</property>
                    <property name="selection-mode">none</property>
                    <child>
                      <object class="GtkFlowBoxChild">
                        <property name="focusable">False</property>
                        <property name="child">
                          <object class="GtkLabel">
                            <property name="wrap">True</property>
                            <property name="hexpand">False</property>
                            <property name="xalign">0</property>
                            <binding name="label">
                              <closure function="format_train_direction" type="gchararray">
                                <lookup name="name">
                                  <lookup name="leg" type="DBLegItem">
                                  </lookup>
                                </lookup>
                                <lookup name="direction">
                                  <lookup name="leg" type="DBLegItem">
                                  </lookup>
                                </lookup>
                              </closure>
                            </binding>
                          </object>
                        </property>
                      </object>
                    </child>

                    <child>
                      <object class="GtkFlowBoxChild">
                        <property name="focusable">False</property>
                        <property name="child">
                          <object class="DBFrequencyLabel">
                            <binding name="frequency">
                              <lookup name="frequency">
                                <lookup name="leg" type="DBLegItem"/>
                              </lookup>
                            </binding>
                          </object>
                        </property>
                      </object>
                    </child>
                  </object>
                </child>
                <child>
                  <object class="GtkBox">
                    <property name="orientation">horizontal</property>
                    <property name="halign">fill</property>
                    <property name="spacing">6</property>
                    <child>
                      <object class="GtkToggleButton" id="stopover_button">
                        <accessibility>
                          <property name="label" translatable="true">Show Stopovers</property>
                        </accessibility>
                        <property name="tooltip-text" translatable="true">Show Stopovers in Between</property>

                        <property name="hexpand">True</property>
                        <property name="halign">start</property>
                        <style>
                          <class name="small-pill"/>
                        </style>
                        <property name="child">
                          <object class="GtkBox">
                            <property name="margin-start">6</property>
                            <property name="spacing">6</property>
                            <child>
                              <object class="GtkLabel" id="label_num_stopovers">
                                <property name="halign">start</property>
                              </object>
                            </child>
                            <child>
                              <object class="GtkImage">
                                <property name="icon-name">go-next-symbolic</property>
                                <property name="visible" bind-source="stopover_button" bind-property="active" bind-flags="sync-create|invert-boolean"/>
                              </object>
                            </child>
                            <child>
                              <object class="GtkImage">
                                <property name="icon-name">go-down-symbolic</property>
                                <property name="visible" bind-source="stopover_button" bind-property="active" bind-flags="sync-create"/>
                              </object>
                            </child>
                          </object>
                        </property>
                      </object>
                    </child>

                    <child>
                      <object class="GtkBox">
                        <property name="halign">end</property>
                        <property name="hexpand">true</property>
                        <property name="spacing">6</property>

                        <child>
                          <object class="DBIndicatorIcons">
                            <property name="hexpand">true</property>
                            <property name="halign">end</property>
                            <binding name="load-factor">
                              <lookup name="load-factor">
                                <lookup name="leg" type="DBLegItem"/>
                              </lookup>
                            </binding>
                            <binding name="late-factor">
                              <lookup name="late-factor">
                                <lookup name="leg" type="DBLegItem"/>
                              </lookup>
                            </binding>
                            <binding name="change-platform">
                              <lookup name="change-platform">
                                <lookup name="leg" type="DBLegItem"/>
                              </lookup>
                            </binding>
                            <binding name="is-unreachable">
                              <lookup name="is-unreachable">
                                <lookup name="leg" type="DBLegItem"/>
                              </lookup>
                            </binding>
                            <binding name="is-cancelled">
                              <lookup name="is-cancelled">
                                <lookup name="leg" type="DBLegItem"/>
                              </lookup>
                            </binding>
                          </object>
                        </child>
                        <child>
                          <object class="GtkToggleButton" id="remarks_button">
                            <accessibility>
                              <property name="label" translatable="true">Show Announcements</property>
                            </accessibility>
                            <property name="tooltip-text" translatable="true">Show Announcements</property>

                            <property name="valign">center</property>
                            <property name="halign">end</property>
                            <property name="icon-name">dialog-information-symbolic</property>
                            <style>
                              <class name="circular"/>
                            </style>
                          </object>
                        </child>
                      </object>
                    </child>
                  </object>
                </child>

                <child>
                  <object class="GtkRevealer">
                    <property name="vexpand">False</property>
                    <property name="child">
                      <object class="GtkBox" id="box_remarks">
                        <property name="spacing">12</property>
                        <property name="margin-start">0</property>
                        <property name="margin-end">18</property>
                        <property name="margin-top">12</property>
                        <property name="margin-bottom">12</property>
                        <property name="orientation">vertical</property>
                      </object>
                    </property>
                    <binding name="reveal-child">
                      <lookup name="active">remarks_button</lookup>
                    </binding>
                    <property name="transition-type">slide-up</property>
                  </object>
                </child>
              </object>
            </child>
          </object>
        </child>

        <child>
          <object class="GtkRevealer">
            <property name="vexpand">False</property>
            <property name="child">
              <object class="GtkBox">
                <property name="orientation">vertical</property>
                <child>
                  <object class="GtkBox" id="box_stopovers">
                    <property name="orientation">vertical</property>
                  </object>
                </child>
                <child>
                  <object class="GtkBox">
                    <property name="orientation">horizontal</property>
                    <property name="height-request">12</property>
                    <child>
                      <object class="AdwBin" id="spacing_2"/>
                    </child>
                    <child>
                      <object class="GtkSeparator">
                        <property name="orientation">vertical</property>
                        <property name="margin-start">18</property>
                        <property name="margin-end">18</property>
                      </object>
                    </child>
                  </object>
                </child>
              </object>
            </property>
            <binding name="reveal-child">
              <lookup name="active">stopover_button</lookup>
            </binding>
            <property name="transition-type">slide-up</property>
          </object>
        </child>

        <child>
          <object class="GtkBox">
            <property name="orientation">horizontal</property>
            <child>
              <object class="DBAltLabel" id="destination_arrival_label">
                <property name="valign">center</property>
                <property name="halign">start</property>
                <binding name="main">
                  <lookup name="planned-arrival">
                    <lookup name="leg" type="DBLegItem">
                    </lookup>
                  </lookup>
                </binding>
                <binding name="alt">
                  <lookup name="arrival">
                    <lookup name="leg" type="DBLegItem">
                    </lookup>
                  </lookup>
                </binding>
              </object>
            </child>
            <child>
              <object class="GtkBox">
                <property name="orientation">vertical</property>
                <child>
                  <object class="GtkSeparator">
                    <property name="orientation">vertical</property>
                    <property name="vexpand">True</property>
                    <property name="halign">center</property>
                    <property name="margin-start">18</property>
                    <property name="margin-end">18</property>
                  </object>
                </child>
                <child>
                  <object class="GtkImage">
                    <property name="icon-name">circle-outline-thick-symbolic</property>
                    <property name="pixel-size">13</property>
                    <property name="hexpand">False</property>
                  </object>
                </child>
                <child>
                  <object class="GtkSeparator">
                    <property name="orientation">vertical</property>
                    <property name="vexpand">True</property>
                    <property name="halign">center</property>
                    <property name="margin-start">18</property>
                    <property name="margin-end">18</property>
                  </object>
                </child>
              </object>
            </child>
            <child>
              <object class="GtkLabel">
                <style>
                  <class name="route-segment-station-start-end"/>
                </style>
                <property name="halign">start</property>
                <property name="ellipsize">end</property>
                <binding name="label">
                  <lookup name="name">
                    <lookup name="destination">
                      <lookup name="leg" type="DBLegItem">
                      </lookup>
                    </lookup>
                  </lookup>
                </binding>
              </object>
            </child>
            <child>
              <object class="DBAltLabel">
                <property name="valign">center</property>
                <property name="halign">end</property>
                <property name="hexpand">True</property>
                <binding name="main">
                  <lookup name="planned-arrival-platform">
                    <lookup name="leg" type="DBLegItem"/>
                  </lookup>
                </binding>
                <binding name="alt">
                  <lookup name="arrival-platform">
                    <lookup name="leg" type="DBLegItem"/>
                  </lookup>
                </binding>
              </object>
            </child>
          </object>
        </child>
      </object>
    </child>
  </template>
</interface>
